#include <iostream>
#include <fstream>
using namespace std;


/*
liczba parzysta - to liczba podzielna przez 2 bez reszty
liczba C-parzysta - to liczba, ktra jest parzysta oraz skada si tylko i wycznie z cyfr parzystych czyli cyfr 0, 2, 4, 6, 8
liczba B-parzysta - to liczba, ktra jest C-parzysta oraz suma cyfr tej liczby zapisanej w binarnym systemie liczbowym jest rwnie parzysta
liczba Super-B-parzysta - to liczba, ktra jest B-parzysta oraz ktra z zapisie binarnych ma jednakow ilo cyfr "1" i cyfr "0"
*/

bool parzysta (unsigned int);
bool c_parzysta(unsigned int);
bool b_parzysta(unsigned int);
bool super_b_parzysta(unsigned int);
string dec2bin (unsigned int);

int main()
{
   	//Zadanie A.
	ifstream file_in;
	file_in.open("dec40000.in");
	int n; //ilo liczb (danych) w pliku wejciowym
	file_in >> n;
	unsigned int * dziesietne = new unsigned int[n];// tablica dynamiczna przechowujca liczby cakowite odczytane z pliku wejciowego
	unsigned int suma = 0; //suma wszystkich liczb w pliku wejciowym - maksymalna warto to 40 000 x 100 000 = 4000 000 000
	for(int i=0;i<n;i++){
		file_in >> dziesietne[i];
		suma+=dziesietne[i];
	}
	double srednia = (double)suma/n; // rednia arytmetyczna wszystkich liczb - rednia moe by liczb uamkow - dlatego typu double
	file_in.close();//zamknicie pliku wejciowego	
	
	ofstream file_out; //plik wyjciowy
	int temp_srednia=0;
	file_out.open("dec40000.out");
	for(int i=0;i<n;i++){
		if(dziesietne[i] >= srednia)
			temp_srednia++;
	}
	cout << "A\n"<< temp_srednia << endl <<endl;
	file_out << "A\n"<< temp_srednia << endl <<endl; //zapis do pliku
	
	//Zadanie B.	
	int ilosci_liczb[100001]={0}; //tablica tymczasowa o indeksach od 0 do 100000 przechowujca iloci powtze liczb bdcych danymi
	for(int i=0;i<n;i++)
		(ilosci_liczb[dziesietne[i]])++;//zapisanie w tablicy iloci wystpie poszczeglnych liczb
	int temp_max=0;
	int temp_index; 
	for(int i=0;i<100001;i++)	
		if(temp_max<ilosci_liczb[i]) //poszukiwanie najwikszej iloci powtrze
			{
				temp_max=ilosci_liczb[i];
				temp_index=i;
			}
	cout << "B\n"<< temp_index << endl <<endl;
	file_out << "B\n"<< temp_index << endl <<endl; //zapis do pliku	
	
	//Zadanie C.
	int temp_c_parzysta=0; //ilo liczb C-parzystych
	for (int i=0;i<n;i++) {
        if (parzysta(dziesietne[i]) && c_parzysta(dziesietne[i])) //warunek na S-parzysto
            temp_c_parzysta++;
	}
    cout << "C\n"<< temp_c_parzysta << endl <<endl;
	file_out << "C\n"<< temp_c_parzysta << endl <<endl; //zapis do pliku	
	
	//Zadanie D.
	int temp_b_parzysta=0; //ilo liczb B-parzystych
	for (int i=0;i<n;i++) {
        if (parzysta(dziesietne[i]) && c_parzysta(dziesietne[i]) && b_parzysta(dziesietne[i])) //warunek na B-przysto
            temp_b_parzysta++;
	}
    cout << "D\n"<< temp_b_parzysta << endl <<endl;
	file_out << "D\n"<< temp_b_parzysta << endl <<endl; //zapis do pliku	
	
	//Zadanie E.
	int temp_super_b_parzysta=0; //ilo liczb Super-B-parzystych
	for (int i=0;i<n;i++) {
        if (parzysta(dziesietne[i]) && c_parzysta(dziesietne[i]) && b_parzysta(dziesietne[i]) && super_b_parzysta(dziesietne[i])) //warunek na Super-B-parzysto
			 temp_super_b_parzysta++;
	}
    cout << "E\n"<< temp_super_b_parzysta << endl <<endl;
	file_out << "E\n"<< temp_super_b_parzysta << endl <<endl; //zapis do pliku	
	file_out.close();
	return 0;
}

// funkcja sprawdzajca czy liczba jest parzysta
bool parzysta(unsigned int liczba) {
    return !(liczba % 2);
}

// funckcja sprawdzajca czy liczba skada si wycznie z cyfr parzystych
bool c_parzysta(unsigned int liczba){
    do{
        int cyfra = liczba % 10;
        liczba = liczba / 10;
        if(cyfra%2==1)
        	return false;
    } while(liczba!=0);
    return true;
}

// funkcja sprawdzajca czy suma cyfr liczby zapisanej w systemie binarnym jest parzysta
bool b_parzysta(unsigned int liczba) {
    string liczba_binarna = dec2bin(liczba); //zamiana liczby dziesitnej na binarn
    int suma_cyfr = 0;
    for (int i = 0; i < liczba_binarna.length(); i++) {
        suma_cyfr += int(liczba_binarna[i]-'0');
    }
    return parzysta(suma_cyfr);
}

// sprawdzenie czy liczba zapisana w systemie binarnym ma jednakow ilo cyfr "1" i cyfr "0"
bool super_b_parzysta(unsigned int liczba){
	string liczba_binarna = dec2bin(liczba);//zamiana liczby dziesitnej na binarn
	int ile_zer=0;
	if (liczba_binarna.length()%2==0){ //tylko liczba posiadajca parzyst ilo cyfr moe mie jednakow ilo cyfr "1" i cyfr "0"
		for (int i = 0; i < liczba_binarna.length(); i++) {
        	ile_zer += int(liczba_binarna[i]-48);
    	}
		if (2*ile_zer==liczba_binarna.length())
			return true;
		else
			return false;
	}
	else
		return false;
}

// zamiana liczby dziesitnej na binarn
string dec2bin(unsigned int liczba) {
   string temp="";
   if (!liczba)
   		string temp="0";
   while (liczba != 0){ 
    	if (liczba % 2 == 0)
			temp+="0";
		else
			temp+="1"; 
    liczba/=2;      
    }
    return temp;
}

